<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#if de.getStorageMode()==1 || de.getStorageMode()==2 ||de.getStorageMode()==4||de.getStorageMode()==0>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.filter.${de.getCodeName()}SearchContext;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.I${de.getCodeName()}Service;

import ${pub.getPKGCodeName()}.util.helper.CachedBeanCopier;
<#if item.getAllPSDELogics()??>
    <#list item.getAllPSDELogics() as logic>
//import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.logic.I${de.getCodeName()}${logic.getCodeName()}Logic;
    </#list>
</#if>


<#comment>SQL存储-Mybatis</#comment>
<#if de.getStorageMode()==1>

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.mapper.${item.getCodeName()}Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;


/**
 * 实体[${item.getLogicName()}] 服务对象接口实现
 */
@Slf4j
@Service("${item.getCodeName()}ServiceImpl")
public class ${item.getCodeName()}ServiceImpl extends ServiceImpl<${de.getCodeName()}Mapper, ${de.getCodeName()}> implements I${de.getCodeName()}Service {

    <#assign keyfield=de.getKeyPSDEField()>

    <#comment>引入关联依赖</#comment>
    <#if de.getMajorPSDERs()??>
        <#list de.getMajorPSDERs() as der>
            <#if der.getDERType() =='DER1N' && (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2||der.getMinorPSDataEntity().getStorageMode()==4)>
                <#if !P.exists('DEMinorPSDataEntity',der.getMinorPSDataEntity().getCodeName())>
    @Autowired
    @Lazy
    private ${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.service.I${der.getMinorPSDataEntity().getCodeName()}Service ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service;
                </#if>
            </#if>
        </#list>
    </#if>
    private int batchSize = 500;

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if deaction.getRender()??>
                    ${deaction.getRender().code}
                <#else>
                    <#if (deaction.getActionType()=='USERCUSTOM')>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        //自定义代码
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return et;
    }

                    <#elseif deaction.getActionType()=='DELOGIC'>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
         //${deaction.getPSDELogic().getCodeName()?lower_case}Logic.execute(et);
         return et ;
    }

                    <#elseif deaction.getCodeName()?lower_case == 'get'>
    @Override
    @Transactional
    public ${item.getCodeName()} get(${srfjavatype(keyfield.stdDataType)} key) {
        ${item.getCodeName()} et = getById(key);
        if(et==null){
            et=new ${item.getCodeName()}();
            et.set${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(key);
        }
        else{
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
                        <#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
            et.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.selectBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key));
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        }
        return et;
    }

                    <#elseif deaction.getCodeName()?lower_case == "createbatch">
                    <#elseif deaction.getCodeName()?lower_case == "updatebatch">
                    <#elseif deaction.getCodeName()?lower_case == "removebatch">
                    <#elseif deaction.getCodeName()?lower_case == "savebatch">
                    <#elseif deaction.getCodeName()?lower_case == "create">
    @Override
    @Transactional
    public boolean create(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        <#comment>成功后get填充一次完整信息</#comment>
        CachedBeanCopier.copy(get(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()),et);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true;
    }

    @Override
    public void createBatch(List<${item.getCodeName()}> list) {
        saveBatch(list,batchSize);
    }

                    <#elseif deaction.getCodeName()?lower_case == "update">
    @Override
    @Transactional
    public boolean update(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        <#if de.getKeyPSDEField()??>
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("${keyfield.name?lower_case}",et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}())))
            return false;
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        <#comment>成功后get填充一次完整信息</#comment>
        CachedBeanCopier.copy(get(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()),et);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true;
        <#else>
        throw new RuntimeException("请检查[${de.getLogicName()}]实体是否存在主键属性");
        </#if>
    }

    @Override
    public void updateBatch(List<${item.getCodeName()}> list) {
        updateBatchById(list,batchSize);
    }

                    <#elseif deaction.getCodeName()?lower_case == "save">
    @Override
    @Transactional
    public boolean save(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        if(!saveOrUpdate(et))
            return false;
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(${item.getCodeName()} et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<${item.getCodeName()}> list) {
        saveOrUpdateBatch(list,batchSize);
    }

                    <#elseif deaction.getCodeName()?lower_case == "remove">
    @Override
    @Transactional
    public boolean remove(${srfjavatype(keyfield.stdDataType)} key) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
                                <#if de.getMajorPSDERs()??>
                                    <#list de.getMajorPSDERs() as der>
                                        <#if der.getDERType() =='DER1N' && der.isNestedRS() && der.getMinorPSDataEntity()?? &&  (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2||der.getMinorPSDataEntity().getStorageMode()==4) >
                                        <#assign MajorDerField = der.getPSPickupDEField()>
                                        <#assign minorKeyField = der.getMinorPSDataEntity().getKeyPSDEField()>
        ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service.removeBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key) ;
                                        </#if>
                                    </#list>
                                </#if>
        if(!removeById(key)) return false;
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true ;
    }

    @Override
    public void removeBatch(Collection<${srfjavatype(keyfield.stdDataType)}> idList) {
        removeByIds(idList);
    }

                    <#elseif deaction.getCodeName()?lower_case == "getdraft">
    @Override
    public ${item.getCodeName()} getDraft(${item.getCodeName()} et) {
        return et;
    }

                    <#elseif deaction.getCodeName()?lower_case == "checkkey">
    @Override
    public boolean checkKey(${item.getCodeName()} et) {
        return (!ObjectUtils.isEmpty(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()))&&(!Objects.isNull(this.getById(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}())));
    }

                    <#else>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        //自定义代码
        return et;
    }

                    </#if>
                </#if>
            </#if>
        </#list>
    </#if>

    <#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>
		<#list de.getMinorPSDERs() as MinorPSDER>
			<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
				<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
					<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
					<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
						<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
							<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
							<#assign MajorField = MinorPSDER.getPSPickupDEField()>
							<#if de.getDefaultPSDEDataSet()??>
								<#assign deDefaultDataSet=de.getDefaultPSDEDataSet()>
								<#if deDefaultDataSet.getPSDEDataQueries()??>
	@Override
    public List<${item.getCodeName()}> selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        return baseMapper.selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case});
    }

    @Override
    public void removeBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        this.remove(new QueryWrapper<${item.getCodeName()}>().eq("${MajorField.getName()?lower_case}",${MajorkeyField.codeName?lower_case}));
    }

	                                <#assign nested=MinorPSDER.isNestedRS()>
                                    <#if nested == false && MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                                        <#list MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                            <#if api.isNested()>
                                                <#assign nested=true>
                                            </#if>
                                        </#list>
                                    </#if>
                                    <#if nested>
	@Override
    public void saveBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case},List<${item.getCodeName()}> list) {
        if(list==null)
            return;
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        List<${item.getCodeName()}> _update=new ArrayList<${item.getCodeName()}>();
        List<${item.getCodeName()}> _create=new ArrayList<${item.getCodeName()}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        for(${item.getCodeName()} sub:list) {
            sub.set${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case});
            if(ObjectUtils.isEmpty(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}()))
                sub.set${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}((${srfjavatype(keyfield.stdDataType)})sub.getDefaultKey(true));
            if(delIds.contains(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}())) {
                delIds.remove(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}

                                    </#if>
								</#if>
							</#if>
						</#if>
					</#if>
				</#if>
			</#if>
		</#list>
	</#if>

    <#comment>输出数据查询</#comment>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    @Override
    public Page<<#if dedataset.isEnableGroup()>HashMap<#else>${item.getCodeName()}</#if>> search${dedataset.getCodeName()}(${item.getCodeName()}SearchContext context) {
            <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
                <#--<#list item.getAllPSDEDBTables() as detable>-->
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<<#if dedataset.isEnableGroup()>HashMap<#else>${item.getCodeName()}</#if>> pages=baseMapper.search${dedataset.getCodeName()}(context.getPages(),context,context.getSelectCond());
        return new PageImpl<<#if dedataset.isEnableGroup()>HashMap<#else>${item.getCodeName()}</#if>>(pages.getRecords(), context.getPageable(), pages.getTotal());
                <#--</#list>-->
            <#else>
        return null ;
            </#if>
    }

        </#list>
    </#if>

    <#comment>输出自定义sql查询</#comment>
    @Override
    public List<JSONObject> select(String sql){
        return this.baseMapper.selectBySQL(sql);
    }

    @Override
    @Transactional
    public boolean execute(String sql){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}

<#comment>NOSQL存储</#comment>
<#elseif de.getStorageMode()==2>

import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().codeName?lower_case}.repository.${de.codeName}Repository;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.BasicQuery;
import org.springframework.data.mongodb.core.query.Query;
import javax.annotation.Resource;

/**
 * 实体[${item.getLogicName()}] 服务对象接口实现
 */
@Slf4j
@Service
public class ${item.getCodeName()}ServiceImpl implements I${de.getCodeName()}Service {

    @Autowired
    private ${item.getCodeName()}Repository repository;
    <#assign keyfield=de.getKeyPSDEField()>

    <#comment>引入关联依赖</#comment>
    <#if de.getMajorPSDERs()??>
        <#list de.getMajorPSDERs() as der>
            <#if der.getDERType() =='DER1N' && (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2||der.getMinorPSDataEntity().getStorageMode()==4)>
                <#if !P.exists('DEMinorPSDataEntity',der.getMinorPSDataEntity().getCodeName())>
    @Autowired
    @Lazy
    private ${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.service.I${der.getMinorPSDataEntity().getCodeName()}Service ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service;
                </#if>
            </#if>
        </#list>
    </#if>

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if deaction.getRender()??>
                    ${deaction.getRender().code}
                <#else>
                    <#if (deaction.getActionType()=='USERCUSTOM')>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        //自定义代码
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return et;
    }

                    <#elseif deaction.getActionType()=='DELOGIC'>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
         //${deaction.getPSDELogic().getCodeName()?lower_case}Logic.execute(et);
         return et ;
    }

                    <#elseif deaction.getCodeName()?lower_case == 'get'>
    @Override
    @Transactional
    public ${item.getCodeName()} get(${srfjavatype(keyfield.stdDataType)} key) {
        Optional<${item.getCodeName()}> result = repository.findById(key);
        if(!result.isPresent()){
            ${item.getCodeName()} et=new ${item.getCodeName()}();
            et.set${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(key);
            return et;
        }
        else{
            ${item.getCodeName()} et=result.get();
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
            et.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.selectBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key));
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
            return result.get();
        }
    }

                    <#elseif deaction.getCodeName()?lower_case == "createbatch">
                    <#elseif deaction.getCodeName()?lower_case == "updatebatch">
                    <#elseif deaction.getCodeName()?lower_case == "removebatch">
                    <#elseif deaction.getCodeName()?lower_case == "savebatch">
                    <#elseif deaction.getCodeName()?lower_case == "create">
    @Override
    @Transactional
    public boolean create(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        repository.insert(et);
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        <#comment>成功后get填充一次完整信息</#comment>
        CachedBeanCopier.copy(get(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()),et);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true ;
    }

    @Override
    public void createBatch(List<${item.getCodeName()}> list) {
        repository.insert(list);
    }

                    <#elseif deaction.getCodeName()?lower_case == "update">
    @Override
    @Transactional
    public boolean update(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        <#if de.getKeyPSDEField()??>
        repository.save(et);
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        <#comment>成功后get填充一次完整信息</#comment>
        CachedBeanCopier.copy(get(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()),et);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true ;
        <#else>
        throw new RuntimeException("请检查[${de.getLogicName()}]实体是否存在主键属性");
        </#if>
    }

    @Override
    public void updateBatch(List<${item.getCodeName()}> list) {
        repository.saveAll(list);
    }

                    <#elseif deaction.getCodeName()?lower_case == "save">
    @Override
    @Transactional
    public boolean save(${item.getCodeName()} et) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
        <#if de.getKeyPSDEField()??>
        repository.save(et);
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2||MajorPSDER.getMinorPSDataEntity().getStorageMode()==4)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        <#comment>成功后get填充一次完整信息</#comment>
        CachedBeanCopier.copy(get(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()),et);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true ;
        <#else>
        throw new RuntimeException("请检查[${de.getLogicName()}]实体是否存在主键属性");
        </#if>
    }


    @Override
    public void saveBatch(List<${item.getCodeName()}> list) {
        repository.saveAll(list);
    }

                    <#elseif deaction.getCodeName()?lower_case == "remove">
    @Override
    @Transactional
    public boolean remove(${srfjavatype(keyfield.stdDataType)} key) {
        <#comment>附加数据逻辑-操作前</#comment>
        <@addBoforeLogic deaction/>
                                <#if de.getMajorPSDERs()??>
                                    <#list de.getMajorPSDERs() as der>
                                        <#if der.getDERType() =='DER1N' && der.isNestedRS() && der.getMinorPSDataEntity()?? &&  (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2||der.getMinorPSDataEntity().getStorageMode()==4) >
                                        <#assign MajorDerField = der.getPSPickupDEField()>
                                        <#assign minorKeyField = der.getMinorPSDataEntity().getKeyPSDEField()>
        ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service.removeBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key) ;
                                        </#if>
                                    </#list>
                                </#if>
        repository.deleteById(key);
        <#comment>附加数据逻辑-操作后</#comment>
        <@addAfterLogic deaction/>
        return true ;
    }

    @Override
    public void removeBatch(Collection<${srfjavatype(keyfield.stdDataType)}> idList) {
        repository.deleteAll(repository.findAllById(idList));
    }

                    <#elseif deaction.getCodeName()?lower_case == "getdraft">
    @Override
    public ${item.getCodeName()} getDraft(${item.getCodeName()} et) {
        return et;
    }

                    <#elseif deaction.getCodeName()?lower_case == "checkkey">
    @Override
    public boolean checkKey(${item.getCodeName()} et) {
        return repository.findById(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()).isPresent();
    }

                    <#else>
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        //自定义代码
        return et;
    }

                    </#if>
                </#if>
            </#if>
        </#list>
    </#if>


    <#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>
		<#list de.getMinorPSDERs() as MinorPSDER>
			<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
				<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
					<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
					<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
						<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
							<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
							<#assign MajorField = MinorPSDER.getPSPickupDEField()>
							<#if de.getDefaultPSDEDataSet()??>
								<#assign deDefaultDataSet=de.getDefaultPSDEDataSet()>
								<#if deDefaultDataSet.getPSDEDataQueries()??>
	@Override
    public List<${item.getCodeName()}> selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        ${item.getCodeName()}SearchContext context=new ${item.getCodeName()}SearchContext();
        context.setN_${MajorField.name?lower_case}_eq(${MajorkeyField.codeName?lower_case});
        Query query = new BasicQuery(context.getSelectCond().get().toString());
        return mongoTemplate.find(query,${item.getCodeName()}.class);
    }

    @Override
    public void removeBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        if(delIds.size()>0)
            this.removeBatch(delIds);
    }

	                                <#assign nested=MinorPSDER.isNestedRS()>
                                    <#if nested == false && MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                                        <#list MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                            <#if api.isNested()>
                                                <#assign nested=true>
                                            </#if>
                                        </#list>
                                    </#if>
                                    <#if nested>
	@Override
    public void saveBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case},List<${item.getCodeName()}> list) {
        if(list==null)
            return;
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        List<${item.getCodeName()}> _update=new ArrayList<${item.getCodeName()}>();
        List<${item.getCodeName()}> _create=new ArrayList<${item.getCodeName()}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        for(${item.getCodeName()} sub:list) {
            sub.set${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case});
            if(ObjectUtils.isEmpty(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}()))
                sub.set${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}((${srfjavatype(keyfield.stdDataType)})sub.getDefaultKey(true));
            if(delIds.contains(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}())) {
                delIds.remove(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}

                                    </#if>
								</#if>
							</#if>
						</#if>
					</#if>
				</#if>
			</#if>
		</#list>
	</#if>
    

    @Resource
    private MongoTemplate mongoTemplate;

    <#comment>输出数据查询</#comment>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    @Override
    public Page<${item.getCodeName()}> search${dedataset.getCodeName()}(${item.getCodeName()}SearchContext context) {
        Query query = new BasicQuery(context.getSelectCond().get().toString());
        long total = mongoTemplate.count(query, ${item.getCodeName()}.class);
        List<${item.getCodeName()}> list=mongoTemplate.find(query.with(context.getPageable()),${item.getCodeName()}.class);
        return new PageImpl<${item.getCodeName()}>(list,context.getPageable(),total);
    }

        </#list>
    </#if>
    

}


<#comment>Api存储</#comment>
<#elseif de.getStorageMode()==4>

import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.client.${item.codeName}FeignClient;

/**
 * 实体[${item.getLogicName()}] 服务对象接口实现
 */
@Slf4j
@Service
public class ${item.getCodeName()}ServiceImpl implements I${de.getCodeName()}Service {

    <#comment>引入feignClient</#comment>
    @Autowired
    ${item.codeName}FeignClient ${item.codeName?uncap_first}FeignClient;

    <#assign keyfield=de.getKeyPSDEField()>

    <#comment>引入关联依赖</#comment>
    <#if de.getMajorPSDERs()??>
        <#list de.getMajorPSDERs() as der>
            <#if der.getDERType() =='DER1N' && (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2)>
                <#if !P.exists('DEMinorPSDataEntity',der.getMinorPSDataEntity().getCodeName())>
    @Autowired
    @Lazy
    private ${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.service.I${der.getMinorPSDataEntity().getCodeName()}Service ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service;
                </#if>
            </#if>
        </#list>
    </#if>

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if deaction.getRender()??>
                    ${deaction.getRender().code}
                <#else>
                    <#if (deaction.getActionType()=='USERCUSTOM')>

                    <#elseif deaction.getActionType()=='DELOGIC'>


                    <#elseif deaction.getCodeName()?lower_case == 'get'>
    @Override
    public ${item.getCodeName()} get(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
                    <#if item.isEnableAPIStorage()>
                        <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
		${item.getCodeName()} et=${item.codeName?uncap_first}FeignClient.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(${keyfield.getCodeName()?lower_case});
        if(et==null){
            et=new ${item.getCodeName()}();
            et.set${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(${keyfield.getCodeName()?lower_case});
        }
        else{
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
            et.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.selectBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key));
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        }

        return  et;
                        <#else>
        return null;
                        </#if>
                    </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "createbatch">
                    <#elseif deaction.getCodeName()?lower_case == "updatebatch">
                    <#elseif deaction.getCodeName()?lower_case == "removebatch">
                    <#elseif deaction.getCodeName()?lower_case == "savebatch">
                    <#elseif deaction.getCodeName()?lower_case == "create">
    @Override
    public boolean create(${item.getCodeName()} et) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.getCodeName()} rt = ${item.codeName?uncap_first}FeignClient.create(et);
        if(rt==null)
            return false;
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(rt.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
        rt.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        CachedBeanCopier.copy(rt,et);
        return true;
                            <#else>
        return false;
                            </#if>
                        <#else>
        return false;
                        </#if>
    }

    public void createBatch(List<${item.codeName}> list){
                    <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.codeName?uncap_first}FeignClient.createBatch(list) ;
                            </#if>
                    </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "update">
    @Override
    public boolean update(${item.getCodeName()} et) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.getCodeName()} rt = ${item.codeName?uncap_first}FeignClient.update(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et);
        if(rt==null)
            return false;
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}()));
        rt.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        CachedBeanCopier.copy(rt,et);
        return true;
                            <#else>
        return false;
                            </#if>
                        <#else>
        return false;
                        </#if>

    }

    public void updateBatch(List<${item.codeName}> list){
                    <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.codeName?uncap_first}FeignClient.updateBatch(list) ;
                            </#if>
                    </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "save">
    @Override
    @Transactional
    public boolean save(${item.getCodeName()} et) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        if(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}()==null) et.set${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}((${srfjavatype(keyfield.stdDataType)})et.getDefaultKey(true));
        if(!${item.codeName?uncap_first}FeignClient.save(et))
            return false;
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>
			<#list de.getMajorPSDERs() as MajorPSDER>
				<#if MajorPSDER??>
					<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()??  && MajorPSDER.getDERType()=='DER1N' &&  (MajorPSDER.getMinorPSDataEntity().getStorageMode()==1||MajorPSDER.getMinorPSDataEntity().getStorageMode()==2)>
						<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
						<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
						<#assign listcode=(MajorPSDER.getMinorCodeName()!MajorPSDER.getMinorPSDataEntity().getCodeName())>
                        <#if listcode?? && listcode==''><#assign listcode=MajorPSDER.getMinorPSDataEntity().getCodeName()></#if>
                        <#assign nested=MajorPSDER.isNestedRS()>
                        <#if nested == false && MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                            <#list MajorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                <#if api.isNested()>
                                    <#assign nested=true>
                                </#if>
                            </#list>
                        </#if>
                        <#if nested>
        ${srfcaseformat(MinorEntity.getCodeName(),'l_u2lC')}Service.saveBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
        rt.set${srfcaseformat(listcode,'l_u2lC')?cap_first}(et.get${srfcaseformat(listcode,'l_u2lC')?cap_first}());
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
        return true;
                            <#else>
        return false;
                            </#if>
                        <#else>
        return false;
                        </#if>
    }

    @Override
    public void saveBatch(List<${item.getCodeName()}> list) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.codeName?uncap_first}FeignClient.saveBatch(list) ;
                            </#if>
                        </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "remove">
    @Override
    public boolean remove(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
                                <#if de.getMajorPSDERs()??>
                                    <#list de.getMajorPSDERs() as der>
                                        <#if der.getDERType() =='DER1N' && der.isNestedRS() && der.getMinorPSDataEntity()?? &&  (der.getMinorPSDataEntity().getStorageMode()==1||der.getMinorPSDataEntity().getStorageMode()==2) >
                                        <#assign MajorDerField = der.getPSPickupDEField()>
                                        <#assign minorKeyField = der.getMinorPSDataEntity().getKeyPSDEField()>
        ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service.removeBy${srfcaseformat(MajorDerField.codeName,'l_u2lC')?cap_first}(key) ;
                                        </#if>
                                    </#list>
                                </#if>
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        return ${item.codeName?uncap_first}FeignClient.remove(${keyfield.getCodeName()?lower_case}) ;
                            <#else>
        return false;
                            </#if>
                        <#else>
        return false;
                        </#if>
    }

    public void removeBatch(Collection<${srfjavatype(keyfield.stdDataType)}> idList){
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.codeName?uncap_first}FeignClient.removeBatch(idList);
                            </#if>
                        </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "getdraft">
    @Override
    public ${item.getCodeName()} getDraft(${item.getCodeName()} et) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        return ${item.codeName?uncap_first}FeignClient.getDraft();
                            <#else>
        return null;
                            </#if>
                        <#else>
        return null;
                        </#if>
    }

                    <#elseif deaction.getCodeName()?lower_case == "checkkey">
    @Override
    public boolean checkKey(${item.getCodeName()} et) {
                        <#if item.isEnableAPIStorage()>
                            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        return ${item.codeName?uncap_first}FeignClient.checkKey(et);
                            <#else>
        return false;
                            </#if>
                        <#else>
        return false;
                        </#if>
    }
                    <#else>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
                <#if item.isEnableAPIStorage()>
                    <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        return ${item.codeName?uncap_first}FeignClient.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(et.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}(),et);
                    <#else>
        return null;
                    </#if>
                    <#else>
        return null;
                </#if>
    }
                    </#if>
                </#if>
            </#if>
        </#list>
    </#if>


    <#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>
		<#list de.getMinorPSDERs() as MinorPSDER>
			<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
				<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
					<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
					<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
						<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
							<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
							<#assign MajorField = MinorPSDER.getPSPickupDEField()>
							<#if de.getDefaultPSDEDataSet()??>
								<#assign deDefaultDataSet=de.getDefaultPSDEDataSet()>
								<#if deDefaultDataSet.getPSDEDataQueries()??>
	@Override
    public List<${item.getCodeName()}> selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        ${item.getCodeName()}SearchContext context=new ${item.getCodeName()}SearchContext();
        context.setSize(Integer.MAX_VALUE);
        context.setN_${MajorField.name?lower_case}_eq(${MajorkeyField.codeName?lower_case});
        return ${item.codeName?uncap_first}FeignClient.search${deDefaultDataSet.getCodeName()}(context).getContent();
    }

    @Override
    public void removeBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        if(delIds.size()>0)
            this.removeBatch(delIds);
    }

	                                <#assign nested=MinorPSDER.isNestedRS()>
                                    <#if nested == false && MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                                        <#list MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                            <#if api.isNested()>
                                                <#assign nested=true>
                                            </#if>
                                        </#list>
                                    </#if>
                                    <#if nested>
	@Override
    public void saveBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case},List<${item.getCodeName()}> list) {
        if(list==null)
            return;
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        List<${item.getCodeName()}> _update=new ArrayList<${item.getCodeName()}>();
        List<${item.getCodeName()}> _create=new ArrayList<${item.getCodeName()}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        for(${item.getCodeName()} sub:list) {
            sub.set${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case});
            if(ObjectUtils.isEmpty(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}()))
                sub.set${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}((${srfjavatype(keyfield.stdDataType)})sub.getDefaultKey(true));
            if(delIds.contains(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}())) {
                delIds.remove(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}

                                    </#if>
								</#if>
							</#if>
						</#if>
					</#if>
				</#if>
			</#if>
		</#list>
	</#if>


    <#comment>输出数据查询</#comment>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    @Override
    public Page<${item.getCodeName()}> search${dedataset.getCodeName()}(${item.getCodeName()}SearchContext context) {
        <#--<#if item.isEnableNoSQLStorage() && item.getAllPSDEDBTables()??>-->
        <#--<#list item.getAllPSDEDBTables() as detable>-->
        Page<${de.getCodeName()}> ${de.getCodeName()?uncap_first}s=${item.codeName?uncap_first}FeignClient.search${dedataset.getCodeName()}(context);
        return ${de.getCodeName()?uncap_first}s;
        <#--</#list>-->
        <#--<#else>-->
        <#--return null ;-->
        <#--</#if>-->
    }

        </#list>
    </#if>

}




<#comment>无存储</#comment>
<#elseif de.getStorageMode()==0>


/**
 * 实体[${item.getLogicName()}] 无存储服务对象接口实现
 */
@Slf4j
@Service
public class ${item.getCodeName()}ServiceImpl implements I${de.getCodeName()}Service {


    <#assign keyfield=de.getKeyPSDEField()>

    <#comment>引入关联依赖</#comment>
    <#if de.getMajorPSDERs()??>
        <#list de.getMajorPSDERs() as der>
            <#if der.getDERType() =='DER1N' >
                <#if !P.exists('DEMinorPSDataEntity',der.getMinorPSDataEntity().getCodeName())>
    @Autowired
    @Lazy
    private ${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.service.I${der.getMinorPSDataEntity().getCodeName()}Service ${srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')}Service;
                </#if>
            </#if>
        </#list>
    </#if>

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if deaction.getRender()??>
                    ${deaction.getRender().code}
                <#else>
                    <#if (deaction.getActionType()=='USERCUSTOM')>

                    <#elseif deaction.getActionType()=='DELOGIC'>


                    <#elseif deaction.getCodeName()?lower_case == 'get'>
    @Override
    public ${item.getCodeName()} get(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
        return null;
    }

                    <#elseif deaction.getCodeName()?lower_case == "createbatch">
                    <#elseif deaction.getCodeName()?lower_case == "updatebatch">
                    <#elseif deaction.getCodeName()?lower_case == "removebatch">
                    <#elseif deaction.getCodeName()?lower_case == "savebatch">
                    <#elseif deaction.getCodeName()?lower_case == "create">
    @Override
    public boolean create(${item.getCodeName()} et) {
        return true;
    }

    public void createBatch(List<${item.codeName}> list){

    }

                    <#elseif deaction.getCodeName()?lower_case == "update">
    @Override
    public boolean update(${item.getCodeName()} et) {
        return true;
    }

    public void updateBatch(List<${item.codeName}> list){
                    
    }

                    <#elseif deaction.getCodeName()?lower_case == "save">
    @Override
    @Transactional
    public boolean save(${item.getCodeName()} et) {
        return true;
    }

    @Override
    public void saveBatch(List<${item.getCodeName()}> list) {
                       
    }

                    <#elseif deaction.getCodeName()?lower_case == "remove">
    @Override
    public boolean remove(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
        return true;
    }

    public void removeBatch(Collection<${srfjavatype(keyfield.stdDataType)}> idList){
                        
    }

                    <#elseif deaction.getCodeName()?lower_case == "getdraft">
    @Override
    public ${item.getCodeName()} getDraft(${item.getCodeName()} et) {
        return null;
    }

                    <#elseif deaction.getCodeName()?lower_case == "checkkey">
    @Override
    public boolean checkKey(${item.getCodeName()} et) {
        return false;
    }
                    <#else>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        return null;
    }
                    </#if>
                </#if>
            </#if>
        </#list>
    </#if>


    <#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>
		<#list de.getMinorPSDERs() as MinorPSDER>
			<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
				<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
					<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
					<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
						<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
							<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
							<#assign MajorField = MinorPSDER.getPSPickupDEField()>
							<#if de.getDefaultPSDEDataSet()??>
								<#assign deDefaultDataSet=de.getDefaultPSDEDataSet()>
								<#if deDefaultDataSet.getPSDEDataQueries()??>
	@Override
    public List<${item.getCodeName()}> selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        return null;
    }

    @Override
    public void removeBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) {
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        if(delIds.size()>0)
            this.removeBatch(delIds);
    }

	                                <#assign nested=MinorPSDER.isNestedRS()>
                                    <#if nested == false && MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                                        <#list MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                            <#if api.isNested()>
                                                <#assign nested=true>
                                            </#if>
                                        </#list>
                                    </#if>
                                    <#if nested>
	@Override
    public void saveBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case},List<${item.getCodeName()}> list) {
        if(list==null)
            return;
        Set<${srfjavatype(keyfield.stdDataType)}> delIds=new HashSet<${srfjavatype(keyfield.stdDataType)}>();
        List<${item.getCodeName()}> _update=new ArrayList<${item.getCodeName()}>();
        List<${item.getCodeName()}> _create=new ArrayList<${item.getCodeName()}>();
        for(${item.getCodeName()} before:selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case})){
            delIds.add(before.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
        }
        for(${item.getCodeName()} sub:list) {
            sub.set${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${MajorkeyField.codeName?lower_case});
            if(ObjectUtils.isEmpty(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}()))
                sub.set${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}((${srfjavatype(keyfield.stdDataType)})sub.getDefaultKey(true));
            if(delIds.contains(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}())) {
                delIds.remove(sub.get${srfcaseformat(keyfield.getCodeName(),'l_u2lC')?cap_first}());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}

                                    </#if>
								</#if>
							</#if>
						</#if>
					</#if>
				</#if>
			</#if>
		</#list>
	</#if>


    <#comment>输出数据查询</#comment>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    @Override
    public Page<${item.getCodeName()}> search${dedataset.getCodeName()}(${item.getCodeName()}SearchContext context) {
        <#--<#if item.isEnableNoSQLStorage() && item.getAllPSDEDBTables()??>-->
        <#--<#list item.getAllPSDEDBTables() as detable>-->
        return null;
        <#--</#list>-->
        <#--<#else>-->
        <#--return null ;-->
        <#--</#if>-->
    }

        </#list>
    </#if>

}
</#if>

<#comment>附加逻辑-操作前</#comment>
<#macro addBoforeLogic deaction>
    <#if deaction.getPSDEActionLogics()??>
        <#list deaction.getPSDEActionLogics() as actionlogic>
            <#if actionlogic.getAttachMode()=='BEFORE'>
                <#if actionlogic.isInternalLogic()>
        //${actionlogic.getPSDELogic().getCodeName()?lower_case}Logic.execute(et);
                <#else>
        //行为处理
                </#if>
            </#if>
        </#list>
    </#if>
</#macro>

<#comment>附加逻辑-操作后</#comment>
<#macro addAfterLogic deaction>
    <#if deaction.getPSDEActionLogics()??>
        <#list deaction.getPSDEActionLogics() as actionlogic>
            <#if actionlogic.getAttachMode()=='AFTER'>
                <#if actionlogic.isInternalLogic()>
        //${actionlogic.getPSDELogic().getCodeName()?lower_case}Logic.execute(et);
                <#else>
        //行为处理
                </#if>
            </#if>
        </#list>
    </#if>
</#macro>
</#if>