<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
<#comment>不发布子系统实体</#comment>
<#if de.isSubSysDE()==false>
    <#assign pubPkgCodeName = pub.getPKGCodeName()>
    <#assign itemSysApiCodeNameLC = item.getPSSysServiceAPI().getCodeName()?lower_case>
package ${pubPkgCodeName}.${itemSysApiCodeNameLC}.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;
import ${pub.getPKGCodeName()}.util.domain.DTOBase;
import lombok.Data;

/**
 * 服务DTO对象[${item.getCodeName()}DTO]
 */
@Data
public class ${item.getCodeName()}DTO extends DTOBase implements Serializable {

	private static final long serialVersionUID = 1L;

    <#if item.getPSDEServiceAPIFields()??>
        <#comment>接口属性集合</#comment>
        <#list item.getPSDEServiceAPIFields() as apifield>
            <#assign defDataType = (apifield.getPSDEField().getDataType())!"">
            <#assign columnname = apifield.getName()?lower_case>
            <#assign prvateCodeName = srfcaseformat(apifield.getCodeName(),'l_u2lC') >
            <#assign publicCodeName = prvateCodeName?cap_first >
            <#assign jsonfield = apifield.getCodeName()?lower_case >
            <#if defDataType!='ONE2MANYDATA'>
    /**
     * 属性 [${apifield.getName()}]
     *
     */
            <#if defDataType == "DATETIME" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="yyyy-MM-dd HH:mm:ss")
            <#elseif defDataType == "DATE" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td")>
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="yyyy-MM-dd")
            <#elseif defDataType == "TIME" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="HH:mm", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="HH:mm")
            <#else>
    @JSONField(name = "${jsonfield}")
            </#if>
    @JsonProperty("${jsonfield}")
    private ${srfjavatype(apifield.getStdDataType())} ${prvateCodeName};

            </#if>
        </#list>
    </#if>

    <#comment>输出set方法用于设置null值</#comment>
    <#list item.getPSDEServiceAPIFields() as apifield>
        <#assign defield = apifield.getPSDEField() >
        <#assign defDataType = (defield.getDataType())!"">
        <#assign columnname = apifield.getName()?lower_case>
        <#assign prvateCodeName = srfcaseformat(apifield.getCodeName(),'l_u2lC') >
        <#assign publicCodeName = prvateCodeName?cap_first >
        <#if defield.isPhisicalDEField()==true && defield.isKeyDEField()==false  && defDataType!='ONE2MANYDATA'>
            <#if defield.getPredefinedType()?? && defield.getPredefinedType()!=''>
            <#else >
    /**
     * 设置 [${apifield.getName()}]
     */
    public void set${publicCodeName}(${srfjavatype(apifield.getStdDataType())}  ${prvateCodeName}){
        this.${prvateCodeName} = ${prvateCodeName} ;
        this.modify("${columnname}",${prvateCodeName});
    }

            </#if>
        </#if>
    </#list>

    <#comment>输出关系数据（子实体）</#comment>
    <#if item.getPSDEServiceAPIRSs()?? >
        <#list item.getPSDEServiceAPIRSs() as apider>
            <#assign der = apider.getPSDER1N() >
            <#if apider.getMinorPSDEServiceAPI().isNested()>
                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
                <#assign subcode = srfcaseformat((der.getMinorCodeName()!der.getMinorPSDataEntity().getCodeName()),'l_u2lC') >
                <#if subcode?? && subcode==''><#assign subcode=srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')></#if>
    /**
     *  [${apider.getMinorPSDEServiceAPI().getName()}]
     */
    @JsonProperty("${subDTOs}")
    @JSONField(name = "${subDTOs}")
	private List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subcode} ;

            </#if>
        </#list>
    </#if>
}

</#if>